@inject Microsoft.Extensions.Localization.IStringLocalizer<App> Localize
@using Microsoft.AspNetCore.Components.Forms
@inject DataService DS
@inject SessionData SD
@inject IJSRuntime JSRuntime
@using BioMap
@implements IDisposable

<Row>
  <Column ColumnSize="ColumnSize.IsFull.OnTablet.Is4.OnDesktop">
    <Field Horizontal="false">
      <FieldLabel ColumnSize="ColumnSize.IsFull.OnTablet.Is8.OnDesktop">@Localize["EMail address"]</FieldLabel>
      <FieldBody ColumnSize="ColumnSize.IsFull.OnTablet.Is8.OnDesktop">
        <Select TValue="string" @bind-SelectedValue="SD.Filters.NotesAuthorFilter">
          <SelectItem TValue="string" Value="@("")"></SelectItem>
          @foreach (var userEMail in DS.GetProtocolAuthors(SD, SD.Filters))
          {
            <SelectItem TValue="string" Value="userEMail">@userEMail</SelectItem>
          }
        </Select>
      </FieldBody>
    </Field>
  </Column>
  <Column ColumnSize="ColumnSize.IsFull.OnTablet.Is8.OnDesktop">
    <Field Horizontal="false">
      <FieldLabel ColumnSize="ColumnSize.IsFull.OnTablet.Is3.OnDesktop">@Localize["Text"]</FieldLabel>
      <FieldBody ColumnSize="ColumnSize.IsFull.OnTablet.Is9.OnDesktop">
        <TextEdit @bind-Text="SD.Filters.NotesTextFilter" />
      </FieldBody>
    </Field>
  </Column>
</Row>

@code {

  protected override void OnInitialized() {
    SD.Filters.FilterChanged += this.FilterChanged;
  }

  private void FilterChanged(object sender, EventArgs e) {
    this.InvokeAsync(() => this.StateHasChanged());
  }

  public void Dispose() {
    SD.Filters.FilterChanged -= this.FilterChanged;
  }
}
